ru.bitel.bgbilling.modules.sorm.common.service

## Interface SormService

-     public interface SormService

  Веб-сервис для обслуги клиентской части модуля.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearStatisticForProject(int sormProjectId)` Удаление статистики для проекта СОРМ
    `void` | `deleteSormProject(int id)` Удаляет проект(выгрузку) СОРМ по его id
    `java.util.List<SormProject>` | `getActiveSormProject()` Возвращает список включенных для выгрузки проекта СОРМ
    `java.util.List<IdTitle>` | `getBillAttributeTypeList()`
    `Preferences` | `getConfig()` Возвращает активный конфиг модуля
    `java.util.List<InstalledInstanceModule>` | `getInstalledEthernetModules()` Возвращает список установленных экземпляров модулей интернета
    `java.util.List<InstalledInstanceModule>` | `getInstalledPhoneModules()` Возвращает список установленных экземпляров модулей телефонии
    `java.util.List<InstalledInstanceModule>` | `getInstalledSormModules()` Возвращает список установленных модулей, по которым может быть выполнена выгрузка для СОРМ
    `java.util.List<InstalledInstanceModule>` | `getInstanceModules(java.lang.String moduleName)` Возвращает список установленных экземпляров модулей по переданному имени модуля
    `java.util.List<IdTitle>` | `getNumberResourceCategoryList(int mid)` Возвращает лист категорий номеров модуля Phone, без выстраивания дерева
    `SormProject` | `getSormProject(int id)` Возвращает проект(выгрузку) СОРМ по id
    `java.util.List<SormProject>` | `getSormProjects()` Возвращает список проектов (выгрузок) СОРМ
    `java.util.List<SormUploadStatistic>` | `getStatistic()` Возвращает записи о выполненых выгрузках
    `void` | `startUpload(SormProject sormProject, boolean isFullUpload)` Запуск единоразовой выгрузки СОРМ
    `void` | `tryUploadToFTPAgain(SormUploadStatistic statistic)` Попытка снова выгрузить файлы на фтп для неудачной выгрузки.
    `void` | `updateSormProject(SormProject sormProject)` Обновляет или добавляет проект(выгрузку) СОРМ

- - ### Method Detail

    - #### getInstalledSormModules

          java.util.List<InstalledInstanceModule> getInstalledSormModules()

      Возвращает список установленных модулей, по которым может быть выполнена выгрузка для СОРМ
      Returns:

    - #### getInstalledEthernetModules

          java.util.List<InstalledInstanceModule> getInstalledEthernetModules()

      Возвращает список установленных экземпляров модулей интернета
      Returns:

    - #### getInstalledPhoneModules

          java.util.List<InstalledInstanceModule> getInstalledPhoneModules()

      Возвращает список установленных экземпляров модулей телефонии
      Returns:

    - #### getInstanceModules

          java.util.List<InstalledInstanceModule> getInstanceModules(java.lang.String moduleName)

      Возвращает список установленных экземпляров модулей по переданному имени модуля
      Parameters:
        `moduleName` - - имя искомого модуля, например bill или npay
      Returns:

    - #### getBillAttributeTypeList

          java.util.List<IdTitle> getBillAttributeTypeList()
                                                    throws ru.bitel.bgbilling.common.BGException

      Returns:
        Возвращает типы аттрибутов заведенных в модуле бухгалтерия
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getConfig

          Preferences getConfig()

      Возвращает активный конфиг модуля
      Returns:

    - #### getSormProjects

          java.util.List<SormProject> getSormProjects()
                                               throws ru.bitel.bgbilling.common.BGException

      Возвращает список проектов (выгрузок) СОРМ
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getSormProject

          SormProject getSormProject(int id)
                              throws ru.bitel.bgbilling.common.BGException

      Возвращает проект(выгрузку) СОРМ по id
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateSormProject

          void updateSormProject(SormProject sormProject)
                          throws ru.bitel.bgbilling.common.BGException

      Обновляет или добавляет проект(выгрузку) СОРМ
      Parameters:
        `sormProject` -
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### deleteSormProject

          void deleteSormProject(int id)
                          throws ru.bitel.bgbilling.common.BGException

      Удаляет проект(выгрузку) СОРМ по его id
      Parameters:
        `id` - - id удаляемого проекта(выгрузки)
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getNumberResourceCategoryList

          java.util.List<IdTitle> getNumberResourceCategoryList(int mid)
                                                         throws ru.bitel.bgbilling.common.BGException

      Возвращает лист категорий номеров модуля Phone, без выстраивания дерева
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getActiveSormProject

          java.util.List<SormProject> getActiveSormProject()
                                                    throws ru.bitel.bgbilling.common.BGException

      Возвращает список включенных для выгрузки проекта СОРМ
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### startUpload

          void startUpload(SormProject sormProject,
                           boolean isFullUpload)
                    throws ru.bitel.bgbilling.common.BGException

      Запуск единоразовой выгрузки СОРМ
      Parameters:
        `sormProject` - - проект СОРМ, по которому необходимо начать выгрузку
        `isFullUpload` - - будет ли полная выгрузку или инкрементальная
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getStatistic

          java.util.List<SormUploadStatistic> getStatistic()
                                                    throws ru.bitel.bgbilling.common.BGException

      Возвращает записи о выполненых выгрузках
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### clearStatisticForProject

          void clearStatisticForProject(int sormProjectId)
                                 throws ru.bitel.bgbilling.common.BGException

      Удаление статистики для проекта СОРМ
      Parameters:
        `sormProjectId` - - id проекта сорм, для которого будет удалена статистика выгрузок
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tryUploadToFTPAgain

          void tryUploadToFTPAgain(SormUploadStatistic statistic)
                            throws ru.bitel.bgbilling.common.BGException

      Попытка снова выгрузить файлы на фтп для неудачной выгрузки.
      Parameters:
        `statistic` - - статистика неудавшейся выгрузки на фтп
      Throws:
        `ru.bitel.bgbilling.common.BGException`